# sc::DistSymmSCMatrix Class Reference

Inheritance diagram for sc::DistSymmSCMatrix:

List of all members.

## Public Member Functions

| DistSymmSCMatrix (const RefSCDimension &, DistSCMatrixKit *)
double | get_element (int, int) const
| Return or modify an element.
void | set_element (int, int, double)
void | accumulate_element (int, int, double)
SCMatrix * | get_subblock (int, int, int, int)
| Return a subblock of this.
SymmSCMatrix * | get_subblock (int, int)
void | assign_subblock (SCMatrix *, int, int, int, int)
| Assign m to a subblock of this.
void | assign_subblock (SymmSCMatrix *, int, int)
void | accumulate_subblock (SCMatrix *, int, int, int, int)
| Sum m into a subblock of this.
void | accumulate_subblock (SymmSCMatrix *, int, int)
SCVector * | get_row (int i)
| Return a row of this.
void | assign_row (SCVector *v, int i)
| Assign v to a row of this.
void | accumulate_row (SCVector *v, int i)
| Sum v to a row of this.
void | accumulate_product_rr (SCMatrix *, SCMatrix *)
void | accumulate (const SymmSCMatrix *)
| Sum m into this.
double | invert_this ()
| Invert this.
double | solve_this (SCVector *)
double | trace ()
| Return the trace.
double | determ_this ()
| Return the determinant of this. this is overwritten.
void | gen_invert_this ()
void | diagonalize (DiagSCMatrix *, SCMatrix *)
| Diagonalize this, placing the eigenvalues in d and the eigenvectors in m.
void | accumulate_symmetric_sum (SCMatrix *)
| Sum into this the products of various vectors or matrices.
void | element_op (const Ref< SCElementOp > &)
| Perform the element operation op on each element of this.
void | element_op (const Ref< SCElementOp2 > &, SymmSCMatrix *)
void | element_op (const Ref< SCElementOp3 > &, SymmSCMatrix *, SymmSCMatrix *)
virtual void | convert_accumulate (SymmSCMatrix *)
Ref< SCMatrixSubblockIter > | local_blocks (SCMatrixSubblockIter::Access)
| Returns iterators for the local (rapidly accessible) blocks used in this matrix.
Ref< SCMatrixSubblockIter > | all_blocks (SCMatrixSubblockIter::Access)
| Returns iterators for the all blocks used in this matrix.
Ref< DistSCMatrixKit > | skit ()

## Protected Member Functions

void | init_blocklist ()
double * | find_element (int i, int j) const
int | element_to_node (int i, int j) const
int | block_to_node (int, int) const
Ref< SCMatrixBlock > | block_to_block (int, int) const
void | error (const char *msg)

## Protected Attributes

Ref< SCMatrixBlockList > | blocklist

## Friends

class | DistSCMatrix
class | DistDiagSCMatrix
class | DistSCVector

## Member Function Documentation

void sc::DistSymmSCMatrix::diagonalize | ( | DiagSCMatrix * | d,
|  | SCMatrix * | m |
| ) |  |  | `[virtual]`

Diagonalize this, placing the eigenvalues in d and the eigenvectors in m.

Implements sc::SymmSCMatrix.

SCMatrix* sc::DistSymmSCMatrix::get_subblock | ( | int | br,
|  | int | er,
|  | int | bc,
|  | int | ec |
| ) |  |  | `[virtual]`

Return a subblock of this.

The subblock is defined as the rows starting at br and ending at er, and the columns beginning at bc and ending at ec.

Implements sc::SymmSCMatrix.

Ref<SCMatrixSubblockIter> sc::DistSymmSCMatrix::local_blocks | ( | SCMatrixSubblockIter::Access |  | ) | `[virtual]`

Returns iterators for the local (rapidly accessible) blocks used in this matrix.

Implements sc::SymmSCMatrix.

The documentation for this class was generated from the following file:

- dist.h